-- ej.ex
-- run the Euphoria to Java Translator
-- (c) 2000 david cuny
-- dcuny@lanset.com


object cmd, result

with trace
without warning

include file.e
include ox_lex.e
include ej.e
include ox_ej.e

oxInit()


procedure convertFile( sequence fileName )

    -- handle input from a file
    sequence d

    -- set to lower case
    fileName = lower( fileName )
    
    -- look for extension
    if not find('.', fileName ) then
        if not equal( dir(fileName & ".ex" ), -1 ) then
            fileName &= ".ex"
        elsif not equal( dir(fileName & ".exw" ), -1 ) then
            fileName &= ".exw"
        elsif not equal( dir(fileName & ".exu" ), -1 ) then
            fileName &= ".exu"
        end if
    end if

    -- set the class name
    setClassName( fileName )

    -- parse the file
    parseFile( fileName )

    -- no error?
    if not oxError then
        writeFiles( fileName )
    end if
    
end procedure


cmd = command_line()
if length( cmd ) = 3 then
    -- parse the requested file
    convertFile( cmd[3] )
else      
    -- get the command
    cmd = prompt_string( "file to translate to java? ")
    convertFile( cmd )
end if

